<template>
  <div class="relative favorite-new">
    <div
      v-show="checkIsFavourite(gameData.GameId)"
      :class="[
        'favourite-no-animation overflow-hidden relative',
        `colorFade-new-${gameData.GameId}`,
      ]"
      @click.stop="
        authenticated
          ? setAndUnsetGameToFavourite(gameData, false, index)
          : checkRedirectToLoginOrToggleDialog()
      "
    >
      <SvgIcon
        id="active-favourite"
        :class-name="[
          'pink-fill',
          `scale-animation-new-${gameData.GameId}`,
          'w-6 h-6',
        ]"
        svg-name="icon-heart-pink"
      />
    </div>
    <SvgIcon
      v-show="!checkIsFavourite(gameData.GameId) && showInactiveIcon"
      id="inactive-favourite"
      :class="[
        'favourite-animation-new',
        `favourite-animation-new-${gameData.GameId}`,
        { 'favorite-fill': !ForMobile },
        { '!opacity-100': ForMobile },
        { show: showInactiveIcon },
        'hidden-on-load',
      ]"
      svg-name="icon-favourite-white"
      @click.stop="
        authenticated
          ? setAndUnsetGameToFavourite(gameData, true, index)
          : checkRedirectToLoginOrToggleDialog()
      "
    />
  </div>
</template>

<script lang="ts" setup>
import { onMounted, onUnmounted, PropType, watch } from "vue";
import { GameBsi } from "@/models/bsiGameList";
import { store } from "~~/store";

const authenticated = computed(() => store.state.auth);

const props = defineProps({
  gameData: {
    type: Object as PropType<GameBsi>,
  },
  checkIsFavourite: {
    type: Function,
    required: true,
  },
  showInactiveIcon: {
    type: Boolean,
    required: true,
  },
  setAndUnsetGameToFavourite: {
    type: Function,
    required: true,
  },
  redirectToLogin: {
    type: Function,
    required: true,
  },
  hovered: {
    type: Boolean,
    required: true,
  },
  ForMobile: {
    type: Boolean,
    default: false,
  },
  toggleDialog: {
    type: Boolean,
    default: false,
  },
});
const { toggleLoginRegisterDialog } = commonHelper;
const checkRedirectToLoginOrToggleDialog = () => {
  return props.toggleDialog
    ? toggleLoginRegisterDialog()
    : props.redirectToLogin();
};
const handleClickOutside = (event) => {
  const favoriteNewElement = event.target.closest(".favorite-new");
  if (!favoriteNewElement) {
    const activeIconEl = document.querySelector(".scale-animation-new");
    const activeContainerEl = document.querySelector(".colorFade-new");
    if (activeIconEl) {
      activeIconEl.classList.remove("scale-animation-new");
    }
    if (activeContainerEl) {
      activeContainerEl.classList.remove("colorFade-new");
    }
  }
};
let wasFavourite = props.checkIsFavourite(props.gameData?.GameId);
onMounted(() => {
  document.addEventListener("click", handleClickOutside);
});
watch(
  () => props.checkIsFavourite(props.gameData?.GameId),
  (isFavourite) => {
    if (wasFavourite && !isFavourite) {
      const inactiveFavoriteIcons = document.querySelectorAll(
        ".favourite-animation-new"
      ) as NodeListOf<HTMLElement>;
      inactiveFavoriteIcons.forEach((inactiveFavoriteIcon) => {
        if (inactiveFavoriteIcon) {
          inactiveFavoriteIcon.style.animation = "none";
        }
      });
    }
    wasFavourite = isFavourite;
  }
);
onUnmounted(() => {
  document.removeEventListener("click", handleClickOutside);
});
</script>

<style lang="css">
.hidden-on-load {
  opacity: 0;
  animation: show-inactive-favorite 0.3s ease-in-out 0.3s forwards;
}

.favourite-no-animation {
  @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-md bg-[rgba(249,209,216,0.2)] items-center justify-center flex;
}
.favourite-animation-new {
  @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-lg opacity-0;
}
@keyframes fadeInFromBottom {
  0% {
    opacity: 0;
    transform: translateY(100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeInFromTop {
  0% {
    opacity: 0;
    transform: translateY(-100%);
  }
  100% {
    transform: translateY(0);
  }
}
@keyframes fadeOutToTop-new {
  0% {
    opacity: 1;
    transform: translateY(0);
  }
  100% {
    opacity: 0;
    transform: translateY(-120%);
  }
}
@keyframes heart-fade-out-new {
  0% {
    fill: #f2748b;
  }
  100% {
    fill: transparent;
  }
}
@keyframes scaleAnimation-new {
  0% {
    transform: scale(1);
  }
  30% {
    transform: scale(0.8);
  }
  35% {
    transform: scale(1.2);
  }
  40% {
    transform: scale(1.1);
  }
  45% {
    transform: scale(1.2);
  }
  80% {
    transform: scale(1.2);
  }
  100% {
    transform: scale(1);
  }
}
@keyframes slideIn {
  0% {
    transform: translateX(-100%);
  }
  100% {
    transform: translateX(0);
  }
}
.favourite-animation-new {
  opacity: 0;
  animation: none;
}
.group:hover .play__now__content_for_animate {
  animation: fadeInFromBottom 0.5s ease-in-out;
}
.group:hover .favourite-animation-new {
  @apply opacity-100;
}
.game-button-hover .group:hover .favourite-animation-new {
  animation: none;
}
.favorite-new .colorFade-new {
  animation: none;
}
.favourite-no-animation:has(.favorite-inactive-delay) {
  position: absolute;
  top: 5px;
  right: 5px;
  background-color: transparent;
  display: flex !important;
  justify-content: center;
  align-items: center;
  z-index: 30;
}
.favourite-no-animation:has(.favorite-inactive-delay) .pink-fill {
  animation: heart-fade-out-new 500ms normal forwards ease-out;
}
.favorite-new
  .favourite-no-animation:not(:has(.favorite-inactive-delay))
  .scale-animation-new {
  animation-iteration-count: 1;
  animation: scaleAnimation-new 2s normal forwards ease-out;
}
.favorite-fill {
  transition: all 300ms ease-out;
}
.favorite-fill:hover {
  fill: #f2748b;
}
.pink-fill {
  fill: #f2748b;
}
.favourite-no-animation:has(.favorite-inactive-delay)
  ~ .favourite-animation-new {
  animation: none;
}
.hidden-on-load.favourite-animation-new {
  opacity: 0;
}
</style>
